VERSION 5.00
Begin VB.Form mainform 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "3D CUBE"
   ClientHeight    =   8625
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   11910
   ClipControls    =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   8625
   ScaleWidth      =   11910
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin VB.TextBox CreditText 
      Enabled         =   0   'False
      Height          =   915
      Left            =   60
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "mainform.frx":0000
      Top             =   7680
      Width           =   1455
   End
   Begin VB.Timer mainTimer 
      Interval        =   1
      Left            =   8880
      Top             =   5040
   End
End
Attribute VB_Name = "mainform"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'coordinates from upper-view:
'up-down=y : left-right=x : other (hard to describe)=z

Const pi = 3.14159265358979, point_amount = 8
Dim x(1 To 8) As Integer, y(1 To 8) As Integer, z(1 To 8) As Integer 'actual coords (non calculated)
Dim camera_x  As Single
Dim camera_y As Single
Dim camera_z  As Single
Dim x_middle As Integer    'center of the viewscreen, defined in form_load
Dim y_middle As Integer
Dim view_angle As Single
Dim obj_angle 'angle to object (for moving camera in circle around it (using COS and SIN))
Sub viewchange() 'update image sub
 'now a bunch of math variables, this increases speed enormously (in order of appearance)
 Dim angle As Single, x_difference As Integer, y_difference As Integer
 Dim distance As Single, z_angle As Single, z_distance As Single, angle_dif As Single
 Dim angle_dif_left As Single, angle_dif_right As Single, punt As Integer
 Dim xpos(1 To 8) As Single, ypos(1 To 8) As Single
 
 Cls 'clean screen
 For punt = 1 To 8 'loop all points
   'now pretending to look at the situation from above, decide
   'which side the point lies on
  If x(punt) > camera_x And y(punt) > camera_y Then angle = 90 + Atn((y(punt) - camera_y) / (x(punt) - camera_x)) / pi * 180 'lower-right
  If x(punt) > camera_x And y(punt) = camera_y Then angle = 90 'right
  If x(punt) > camera_x And y(punt) < camera_y Then angle = 90 - Atn((camera_y - y(punt)) / (x(punt) - camera_x)) / pi * 180 'upper-right
  If x(punt) = camera_x And y(punt) < camera_y Then angle = 0 'upper
  If x(punt) = camera_x And y(punt) > camera_y Then angle = 180 'lower
  If x(punt) < camera_x And y(punt) > camera_y Then angle = 270 - Atn((y(punt) - camera_y) / (camera_x - x(punt))) / pi * 180  'lower-left
  If x(punt) < camera_x And y(punt) = camera_y Then angle = 270 'lleft
  If x(punt) < camera_x And y(punt) < camera_y Then angle = 270 + Atn((camera_y - y(punt)) / (camera_x - x(punt))) / pi * 180 'upper-left
 
  'just some distances
  y_difference = Abs(camera_y - y(punt))
  x_difference = Abs(camera_x - x(punt))

   distance = Sqr(x_difference ^ 2 + y_difference ^ 2) 'calculate distance to camera
    Select Case z(punt) 'check point's height
     Case Is > camera_z 'more than current height
      z_distance = z(punt) - camera_z 'calculate vertical distance
      z_angle = Atn(z_distance / distance) / pi * 180 'calculate vertical angle
     Case Is = camera_z 'if it's the same
      z_angle = 0 'make angle 0 so the point will be vertically centered
     Case Is < camera_z 'less than current height
      z_distance = camera_z - z(punt) 'calculate vertical distance
      z_angle = Atn(-(z_distance) / distance) / pi * 180 'calcualte vertical angle
    End Select 'case dismissed
    
      
     'calculate left-angle-dif and right_angle_dif from view_angle
      If view_angle - angle < 0 Then angle_dif_left = (360 - angle) + view_angle Else: angle_dif_left = view_angle - angle
      If angle - view_angle < 0 Then angle_dif_right = (360 - view_angle) + angle Else: angle_dif_right = angle - view_angle

     'decide which angle_difference to use
     If angle_dif_left < angle_dif_right Then angle_difference = -(angle_dif_left)
     If angle_dif_right < angle_dif_left Then angle_difference = angle_dif_right
     If angle_dif_right = angle_dif_left Then angle_difference = 0
     
     'now save the calculated points in an array
     xpos(punt) = x_middle + angle_difference * 240
     ypos(punt) = y_middle - z_angle * 240
   
'   If punt = 1 Then 'if the current point is point(1)
'    'show a bunch of info
'    statusList.List(0) = "angle: " & angle
'    statusList.List(1) = ""
'    statusList.List(2) = "Position: " & position_2d
'    statusList.List(3) = "Current x: " & Str(current_x)
'    statusList.List(4) = "Current y: " & Str(current_y)
'    statusList.List(5) = "Current z: " & Str(current_z)
'    statusList.List(6) = "Distance: " & distance
'    statusList.List(7) = "Angle_difference: " & angle_difference
'    statusList.List(8) = "X_center: " & x_middle
'    statusList.List(9) = "Z_center: " & y_middle
'    statusList.List(10) = "Angle_dif_left: " & angle_dif_left
'    statusList.List(11) = "Angle_dif_right: " & angle_dif_right
'    statusList.List(12) = "z_angle: " & z_angle
'   End If
 
 Next punt
    
 Line (xpos(1), ypos(1))-(xpos(2), ypos(2))
 Line (xpos(2), ypos(2))-(xpos(4), ypos(4))
 Line (xpos(4), ypos(4))-(xpos(3), ypos(3))
 Line (xpos(3), ypos(3))-(xpos(1), ypos(1))
 Line (xpos(5), ypos(5))-(xpos(6), ypos(6))
 Line (xpos(6), ypos(6))-(xpos(8), ypos(8))
 Line (xpos(8), ypos(8))-(xpos(7), ypos(7))
 Line (xpos(7), ypos(7))-(xpos(5), ypos(5))
 Line (xpos(1), ypos(1))-(xpos(5), ypos(5))
 Line (xpos(2), ypos(2))-(xpos(6), ypos(6))
 Line (xpos(3), ypos(3))-(xpos(7), ypos(7))
 Line (xpos(4), ypos(4))-(xpos(8), ypos(8))

End Sub 'end of main sub

Private Sub Form_Load() 'program start sub
 x_middle = mainform.Width / 2
 y_middle = mainform.Height / 2
 view_angle = 0
 obj_angle = 180
 
 'now here are some sample coordinates, they form a cube
 x(1) = -10: y(1) = -10: z(1) = -10
 x(2) = -10: y(2) = -10: z(2) = 10
 x(3) = -10: y(3) = 10: z(3) = -10
 x(4) = -10: y(4) = 10: z(4) = 10
 x(5) = 10: y(5) = -10: z(5) = -10
 x(6) = 10: y(6) = -10: z(6) = 10
 x(7) = 10: y(7) = 10: z(7) = -10
 x(8) = 10: y(8) = 10: z(8) = 10
 viewchange 'initial pixeling
End Sub

Private Sub mainTimer_Timer()
 'change the angles
 view_angle = view_angle - 1: If view_angle < 0 Then view_angle = view_angle + 360
 obj_angle = obj_angle - 1: If obj_angle < 0 Then obj_angle = obj_angle + 360
 'remove camera position around object, and change view_angle so that camera
 'stays looking at object
 camera_x = 0 + Sin(obj_angle / 180 * pi) * 100
 camera_y = 0 - Cos(obj_angle / 180 * pi) * 100
 viewchange
End Sub
